import { Deck } from "../components/Deck";

<Deck>

{/* Just six months ago, in May of this year, the Next.js team - which
essentially is the React.js team, nowadays - announced the stable release of the
Next.js app router. And with that, what they essentially said was that they
believe React Server Components to now be ready for production use. */} {/* So I
have a question for you all. I'm looking for someone - on behalf of recruiters
everywhere - with at least ten years of production experience with React Server
Components. */} {/* Obviously no one has that experience. All this is very new.
So this means that as a community, we still have a lot to figure out, such as
usage patterns, best practices, common pitfalls... Now, this announcement
happened to come at a good time for my team, and we were able to get a feet wet
and start using React, on the server, in a relatively low-risk way.  And today,
I want to share our experience with you. I'll share the challenges we faced, and
some observations I made along the way. And by the end, you should have a better
idea of whether there might be something there that might be of interest to you. */}
{/* As a caveat, this should all be applicable to React in general, but of
course, in practice, Next.js is the only viable way to use this right now, so
apologies if I made a mistake there. */}
# React on the server

## In practice

---

{/* Hi! My name is Vincent, and I work at Mozilla. Which you might know from a project called */}
![](mozilla-logo.svg)

---

![](firefox-logo.svg)

---

{/* ...which I don't work on. */}
![](mozilla-not-firefox.png)

---

{/* What not everyone might know is that Mozilla is a non-profit. We exist to
keep the internet open and accessible to all, and we've got a "Manifesto" and
all that jazz. One way we do that is through Firefox. But there's a lot more
that Mozilla does, such as lobbying, handing out grants, and building other
products in service of that mission. Such as the one I work on. */}
![](mission.png)

---

{/* Firefox Monitor exists to let you know when your data has been leaked. It
has been chugging along for a while now, but this year, we decided we wanted to
do more with it. We wanted to be more pro-active in helping people know what to
do when their data has been exposed, and add a couple of new features. */}
![](monitor.png)

---

{/* Now, the existing app had been chugging along for a while. There was a bit
of clever trickery to protect your data, but in essence, it was an Express.js
app that served up some HTML, CSS, and some hand-crafted client-side JS. */}
![](diagram-express.svg)

{/*
---

{/* Now, does anyone remember this blog post? The gist of it is: never, ever do
a rewrite of your software. I don't actually fully agree with this post as
gospel - I have done rewrites successfully in the past, when the conditions were
right. And in fact, his prime example here is the rewrite of Netscape, which in
the end gave us Firefox, so... */}
{/* Still, it's a good rule-of-thumb. It *can*, and likely will, go horribly
wrong. And what you *especially* shouldn't do, is rewrite your software using
unproven technology. */}
{/* So of course, when Next.js announced that the app router was
production-ready, we decided to adopt it for our app. */}
{/*![](no-rewrites.png)

---

{/* Well, sort-of, but I'll get to that. */}
{/* But basically, while the Express app worked well, we had a bunch of
engineers come on board with varying backgrounds and experiences, and it didn't
lend itself well to parallelisation of the work that was ahead of us. */}
{/* And since we already had other React projects, we wanted to move in that
direction. */}
{/* (But isn't it hilarious that I can introduce what we decided to do with this
image as the backdrop? I'm sure the "everything old is new again" folks will
have a field day with this.) */}
{/* Anyway, let me justify our strategy by considering architecture. */}
{/*![](facepalm.jpg)
*/}

---

{/* Here's the traditional SPA, like you might create with e.g. Create React
App. Basically, the server sends what amounts to an empty HTML page to the
browser, alongside some JavaScript. That JS then initialises React, which
constructs a model in memory of what the DOM should look like, and then updates
the DOM to display something in the browser. */}
{/* This model made it more feasible to have highly interactive interfaces, but
that initial empty page is jarring. */}
![](diagram-spa.svg)

---

{/* Those of you who've used Gatsby or Next.js might be familiar with this
solution: instead of sending a blank page, the sever sends an initial HTML
payload. This would be generated either at build time, if it's static content,
or on the server, if it's personalised to the user. (These are also known as
SSG: Static Site Generation and SSR: Server-Side Rendering.) Either way, the
browser can already show something initially on page load, then React gets
initialised and constructs the virtual DOM, and then "hydrates" the actual DOM,
attaches event listeners. etc. Then when e.g. someone clicks a button, a new
version of the Virtual DOM is generated, and then the Actual DOM is updated to
match. */}

![](diagram-nextjs-pages.svg)

---

{/* This looks very similar to the previous slide, except that I removed the
blue background of a couple of components — these are inside *Server
Components*. These components are rendered once per requests, on the server, and
then never updated on the client side. Client-side interactivity is limited to
elements that are inside *Client Components*. The Virtual DOM still needs to be
aware of these components so it can put the Client Components in the right
place, but it doesn't otherwise need to care about them. */}
{/* The flip side is that this allows for some further performance
optimisations, and to run server-specific code inside Server Components, e.g. to
fetch data. */}
{/* One interesting thing is that this provided us with a path to relatively
quickly migrate our existing app from Express.js to Next.js. Most of the page is
rendered on the server-side, then React builds a model of those parts once on
the client-side, and then leaves them alone. It only concerns itself with
client-side interactions for the DOM nodes with the teal-coloured backgrounds.
Now compare this to our original Express.js app.
*/}
![](diagram-nextjs-app.svg)

---

{/* We decided to do something that won't win any awards for elegance, but it
did work: we just converted the HTML our Express app was returning into Server
Components, and then added `<script>` tags to those Server Components. So then
the server would serve those as plain HTML, React wouldn't do much with them,
and our existing JS continued to work with few modifications. */}
{/*
![](diagram-express.svg)
---
*/}

{/* So compared to the original Express.js app, the addition is that React also
constructs a Virtual DOM on page load that it then doesn't do anything with. */}
{/* I'm not *particularly* happy about this, as we're still running a bunch of
code that essentially doesn't do anything at this point. But it allows us to
keep working on and deploying the same codebase, and to keep re-using much of
the backend code, while implementing the new designs on individual, new pages. */}
{/* And most importantly: we were able to validate this approach in a very short
amount of time, and if it hadn't turned out to be production-ready, and our
backup plan of a proper conversion to React would've been able to re-use much of
the same work we did. And then while we started working on new feature work,
which wasn't set to go live yet, Server Components would have more time to
mature. */}
{/* So the question is: was it production-ready? Well, sufficiently enough to
deploy this kludge, and to move forward basing our new feature work on Server
Components. And as we're putting the finishing touches to our new feature work,
we've got a couple of takeaways and first impressions. These will mostly be
challenges, as I'm sure our approaches won't be the final word on how we want to
handle these in the long term. */}
![](diagram-migration.svg)

---

{/* I'll start with our greatest challenge, and I still can't say we're as
confident as I'd like us to be. */}

{/* Now, if you were around before Node.js, or have a non-JS backend, things
were relatively simple: your JS code ran in the browser, and your
Java/PHP/ASP/whatever ran on the server, and was probably even maintained by
someone else. Then Node.js came along, and suddenly we could write the same code
on both the server and the client! */}
{/* Well... Sort of. The language is the same, but the runtime, the available
APIs, were different. You couldn't call `window.location` on the server, and you
couldn't call `fs.writeFile` on the client. So you had to either very
consciously decide where some piece of code was going to run, or write your code
in such a way that it would run in either runtime. */}
{/* Then Server-Side Rendering muddied the water some more. Traditional client
code, i.e. your React components, now also ran on the server for their first
render, and you had to wrap strictly client-side APIs in e.g. useEffect.  So
it's a bit more complex, but the user no longer has to wait for JS to execute in
order to see something. That said, the page won't be interactive until the DOM
has been hydrated, which can take a while. */}
{/* So with Server Components, React — and, let's be honest, Next.js — tweaked
this model some more. Now, some components _only_ run on the server, and thus
have access to server-side APIs — but they still look similar to other
components. So the biggest learning curve at the moment is to really grasp the
mental model of where your code runs. */}

## Observation 1

> It's hard to know where your code runs

---

{/* Server Components run on the server/in CI, and _only_ on the server. Client
Components, confusingly, _also_ run on the server, _and_ on the client. Except
for event handlers, effects, etc. — those _only_ run on the client. I'm hoping
this overview is useful, but you have to actually work with it for a while to
internalise it, which especially for casual contributors can be a challenge. */}
{/* The next observation is a bit of a corrolary of this one. */}
|                                   | Runs on server/in CI | Runs on client |
| :-------------------------------- | :------------------: | :------------: |
| Server component                  |          ✅          |       ❌       |
| Client component                  |          ✅          |       ✅       |
| Effects, event handlers, &hellip; |          ❌          |       ✅       |

---

{/* You need to be more mindful of when and how you're passing data from the
server to the client. It looks just like regular passing of props, but it's more
like calling an API. This means that you have to be conscious of the shape of
your data, which needs to be representable as JSON. So strings and data objects
are fine, but functions and class instances are not.
It also means you have to be mindful about whether you even want data to be
available on the client. For example, it's easier to accidentally leak secret
keys. */}
{/* Now, this sounds like there is a lot to learn. And there is! But the good
news is: */}

## Observation 2

> Server-client handoff: not straightforward

---

{/* You already know Client Components. All pre-Server Components components are
already Client Components — we just didn't call them that yet. And yes, if you
did Server-Side Rendering, they already run on the server. And the other bit of
good news is: */}

## Observation 3

> You already know Client Components

(and also their name sucks)

---

{/* Large parts of your application will still be Client Components. As soon as
you want some client-side interactivity, you'll need to use Client Components.
*/}
{/* That's state, context, effects, event handlers... All of those require `"use
client"` annotations — and that's OK! Don't fear the Client Components. This
presentation, for example, is a Next.js application, and it's basically all
Client Components — after all, I have to keep track of which slide we're
currently at. */}
{/* And of course, this means that you can migrate gracefully: add a `"use
client"` annotation to your root component, and nothing will have changed. You
can then choose to adopt, or not adopt, Server Components at your own pace. */}
{/* Which is good, because... */}

## Observation 4

> Client-side interactivity? Client component.
---

{/* We still have a lot to figure out. Client-side interactivity goes into
Client Components, but do we still want to rely on client-side interactivity to
the same extent? */}
{/* It used to be somewhat simple: we'd fetch all the data we need, and then create
an interactive client-side app. But now that it's easier to run code on
the server, should we do that? Do we refetch the same data on every page load?
As an example, we have a multi-step form. Does every step go on a separate page?
Or do we keep a large object with the entire form state on the client-side? */}
{/* So yeah, there's lots here still to figure out for us as a community. I
hope I've set all your mental gears in motion, and you can all start coming up
with patterns and best practices. */}
{/* Now, start getting your questions ready while I do a quick recap of my
observations, so you can be the brave soul that asks the first question. */}

## Observation 5

> Still to figure out: What type of component, when?

---

{/* The biggest challenge is forming a mental model of where your code runs, and
then how data is transferred between those different runtimes. The good thing is
that we have lots of existing knowledge that we can build on, since we already
know Client Components, and large parts of our application continue to consist
of Client Components. But there's still lots to figure out in terms of where we
draw the lines, and that's where you all come in. */}
{/* Thank you for being here, and if you don't feel like asking a question now,
or come up with something to discuss later, hit me up afterwards, or on Mastodon
or through my website. */}

## Observations — recap

1. It's hard to know where your code runs
2. Server-client handoff: not straightforward
3. You already know Client Components
4. Client-side interactivity? Client component.
5. Still to figure out: What type of component, when?

<address>
  [@VincentTunru@fosstodon.org](https://fosstodon.org/@VincentTunru) ·
  [VincentTunru.com](https://VincentTunru.com)
</address>

</Deck>
